mode(-1);
//---------------------------------------------------------------------
// This builder.sce file comes from GUIDELINE contribution
// and has been customed for ImLab 2.1 contribution
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Visual C path
VC_PATH1='C:\Program Files\Microsoft Visual Studio\VC98'

// Name of Scilab function library
libname='imlab'

OBJFILELIB=	'imlab.a'
WINLIBRARY=	'imlab.lib'
DLLNAME=	'imlab.dll'

INTERFACE_FILE= 'imlab_gateway.o'

COBJFILES=	'int_imread.o '+..
		'int_immaskgreylevel.o '+..
		'int_immaskrgb.o '+..
		'int_createcmap.o '+..
		'int_createcmap128colors.o '+..
		'int_createcmap256colors.o '+..
		'int_createcmap4096colors.o '+..
		'int_imerode.o '+..
		'int_imdilate.o '+..
		'int_imaverage.o '+..
		'int_imhist.o '+..
		'int_improfilegreylevel.o '+..
		'int_improfilergb.o '+..
		'int_createmask.o '+..
		'int_write_pgm.o '+..
		'int_write_ppm.o '+..
		'int_write_png_rgb.o '+..
		'int_write_png_gray.o '+..
		'int_imotsu.o '+..
		'int_imderiche.o '+..
		'int_imlabel.o '+..
		'int_imclosehole.o '+..
		'int_imconvol.o '+..
		'int_imshencastan.o '+..
		'int_imxyz2lab.o '+..
		'int_imhist3D.o '+..
		'int_immedian.o '+..
		'int_immaxconnex.o '+..
		'int_imshapeanalysis.o '+..
		'int_imdcmelement.o '+..
		'int_imdcmheader.o '+..
		'int_imstandarddeviation.o '+..
		'int_hypermatrix.o '+..
		'int_imlearningdata.o '+..
		'int_imkmeanstrain.o '+..
		'int_imkmeansclassify.o '+..
		'int_imfuzzykmeanstrain.o '+..
		'int_imfuzzykmeansclassify.o '+..
		'int_imfuzzykmeansclassify_2.o '+..
		'int_imhierarclustrain.o '+..
		'int_imkohonentrain.o '+..
		'int_imvote.o '+..
		'int_imgrowing.o '

COBJFILESWIN=strsubst(COBJFILES,'.o','.obj')

INTERFACE_FILE_WIN= strsubst(INTERFACE_FILE,'.o','.obj')

disp('Making all in ImLab2.1 contribution');
disp('Be patient, this may take a while')

// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end
	// Path of the macros directory
	MACROS=DIR+'macros/'
	// Path of the C-source files directory
	SRC=DIR+'src/'
	// Create Makefile for source files
	u=file('open',SRC+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'IMLABDIR = '+DIR
		'LIBRARY = '+OBJFILELIB // Object file library
		'OBJSF = '//Fortran objects (do not include interface)
		'OBJSC = '+COBJFILES //C objects (do not include interface)
		'include '+SCI+'/Makefile.incl'

		'CFLAGS_TIFF = -I./tiff-v3.5.7/libtiff/' // libtiff library
		'CFLAGS_CTN = -I./ctn-v3.0.2/libctn/' // ctn library
		'CFLAGS_CLUST = -I./clustering/libclustering/' // clustering library
		'CFLAGS_PNG = -I./libpng-1.2.8/libpng/' // png library
		'CFLAGS_ZLIB = -I./zlib-1.2.3/zlib/' // zlib library
		'CFLAGS_JPEG = -I./jpeg-6b/jpeg/' // JPEG library
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(CFLAGS_TIFF) $(CFLAGS_CTN) $(CFLAGS_CLUST) $(CFLAGS_PNG) $(CFLAGS_ZLIB) $(CFLAGS_JPEG) -O2 '

		'FFLAGS_TIFF = -I./tiff-v3.5.7/libtiff/' // libtiff library
		'FFLAGS_CTN = -I./ctn-v3.0.2/libctn/'// ctn library
		'FFLAGS_PNG = -I./libpng-1.2.8/libpng/' // libpng library
		'FFLAGS_ZLIB = -I./zlib-1.2.3/zlib/' // zlib library
		'FFLAGS_JPEG = -I./jpeg-6b/jpeg/' // JPEG library
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(FFLAGS_TIFF) $(FFLAGS_CTN) $(FFLAGS_PNG) $(FFLAGS_ZLIB) $(FFLAGS_JPEG) '
		'include '+SCI+'/routines/Make.lib'
		'all :: '+INTERFACE_FILE],'(a)') // Interface object
	file('close',u)
	cmd_make='make'

	// Compile CTN library
	OLD=getcwd();
	chdir(SRC+'ctn-v3.0.2/');
	execstr('exec builder.sce');

	// Compile TIFF library
	chdir(SRC+'tiff-v3.5.7/');
	execstr('exec builder.sce')

	// Compile clustering library
	chdir(SRC+'clustering/');
	execstr('exec builder.sce')

	// Compile PNG library
	chdir(SRC+'libpng-1.2.8/');
	execstr('exec builder.sce')

	// Compile zlib library
	chdir(SRC+'zlib-1.2.3/');
	execstr('exec builder.sce')

	// Compile JPEG library
	chdir(SRC+'jpeg-6b/');
	execstr('exec builder.sce')

	chdir(OLD);

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
  	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	// Path of the macros directory
	MACROS=DIR+'macros\'

	// Path of the C-source files directory
  	SRC=DIR+'src\'

	// Scilab path under Windows
  	SCI_WIN=strsubst(SCI,'/','\')

	// Part used to copy $SCI/Makefile.incl.mak has been removed
	// See CopyMakefile.sce and CopyMakefile for more information

	// Create Makefile
	disp('Creating Makefile')
  	u=file('open',SRC+'Makefile','unknown')
  	tab=code2str(-40)

	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
  		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'DUMPEXTS = ""'+SCI_WIN+'\bin\dumpexts.exe""'
		'TIFFIMPLIB= ""'+SRC+'tiff-v3.5.7\libtiff\libtiff.lib""' // libtiff library
		'CTNIMPLIB= ""'+SRC+'ctn-v3.0.2\libctn\libctn.lib""' // ctn library
		'CLUSIMPLIB= ""'+SRC+'clustering\libclustering\libclustering.lib""' // clustering library
		'PNGLIB= ""'+SRC+'libpng-1.2.8\libpng\libpng.lib""' // libpng library
		'ZLIB= ""'+SRC+'zlib-1.2.3\zlib\zlib.lib""' // zlib library
		'JPEGLIB= ""'+SRC+'jpeg-6b\jpeg\jpeg.lib""' // jpeg library
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib"" $(TIFFIMPLIB) $(CTNIMPLIB) $(CLUSIMPLIB) $(PNGLIB) $(ZLIB) $(JPEGLIB) '
  		'LIBRARY = '+WINLIBRARY // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+COBJFILESWIN+' '+INTERFACE_FILE_WIN //C objects files
  		'include ..\Makefile.incl.mak'

		'CFLAGS_TIFF= -I"".\tiff-v3.5.7\libtiff""' // libtiff library
		'CFLAGS_CTN = -I"".\ctn-v3.0.2\libctn""' // ctn library
		'CFLAGS_CLUST = -I"".\clustering\libclustering""' // clustering library
		'CFLAGS_PNG = -I"".\libpng-1.2.8\libpng""' // png library
		'CFLAGS_ZLIB = -I"".\zlib-1.2.3\zlib""' // zlib library
		'CFLAGS_JPEG = -I"".\jpeg-6b\jpeg""' // JPEG library
		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+VC_PATH1+'\Include"" -I""'+SCI_WIN+'\routines"" $(CFLAGS_TIFF) $(CFLAGS_CTN) $(CFLAGS_CLUST) $(CFLAGS_PNG) $(CFLAGS_ZLIB) $(CFLAGS_JPEG) '

		'FFLAGS_TIFF= -I"".\tiff-v3.5.7\libtiff""'
		'FFLAGS_CTN = -I"".\ctn-v3.0.2\libctn""' // ctn library
		'FFLAGS_PNG = -I"".\libpng-1.2.8\libpng""' // libpng library
		'FFLAGS_ZLIB = -I"".\zlib-1.2.3\zlib""' // zlib library
		'FFLAGS_JPEG = -I"".\jpeg-6b\jpeg""' // JPEG library
		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""'+VC_PATH1+'\include"" $(FFLAGS_TIFF) $(FFLAGS_CTN) $$(FFLAGS_PNG) $(FFLAGS_ZLIB) $(FFLAGS_JPEG) '
  		' '
  		'all :: '+DLLNAME // Dynamic library
  		' '
  		DLLNAME+' : $(OBJSC)'
  		tab+'@$(DUMPEXTS) -o ""$*.def"" ""$*.dll"" $**'
  		tab+'@$(LINKER) $(LINKER_FLAGS) $(OBJSC) $(OBJSF) $(SCIIMPLIB) $(XLIBSBIN)'+..
  		' $(TERMCAPLIB) /nologo /dll /out:""$*.dll"" /implib:""$*.ilib"" '+..
  		'/def:""$*.def""'
  		'distclean ::'
  		tab+'@del *.obj';
  		tab+'@del *.dll'
  		tab+'@del *.ilib'
  		tab+'@del *.def'],'(a)')
  	file('close',u)
	cmd_make='nmake /f Makefile'

	OLD=getcwd();

	// Building LIBTIFF library
	chdir(SRC+'\tiff-v3.5.7\')
	disp('Compiling LIBTIFF library.');
	execstr('exec builder.sce');

	// Building CTN library
	chdir(SRC+'\ctn-v3.0.2\')
	disp('Compiling CTN library.');
	execstr('exec builder.sce');

	// Compile clustering library
	chdir(SRC+'clustering\');
	execstr('exec builder.sce')
	chdir(OLD);

	// Compile PNG library
	chdir(SRC+'libpng-1.2.8\');
	execstr('exec builder.sce')

	// Compile zlib library
	chdir(SRC+'zlib-1.2.3\');
	execstr('exec builder.sce')

	// Compile JPEG library
	chdir(SRC+'jpeg-6b\');
	execstr('exec builder.sce')


end

// compile Fortran and C sources in src

OLD=getcwd();
chdir(SRC)
disp('Compiling library')
unix_s(cmd_make)
chdir(OLD);

//compile sci files if necessary and build lib file
disp('Compiling *.sci')
genlib(libname,MACROS)

clear VC_PATH1 OBJFILELIB WINLIBRARY DLLNAME INTERFACE_FILE COBJFILES COBJFILESWIN nams DIR MACROS SRC cmd_make SCI_WIN OLD
