mode(-1);
//---------------------------------------------------------------------
// This loader.sce file comes from GUIDELINE contribution
// and has been customed for ImLab 2.0 contribution
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Path to C library libgcc.a
LIBGCC = [];

//In case of __eprintf error uncomment and custom the following line
//LIBGCC = ' /usr/local/lib/gcc-lib/sparc-sun-solaris2.6/2.95.2/libgcc.a '

TIFFLIB = 'tiff-v3.5.7/libtiff/libtiff.a '
CTNLIB = 'ctn-v3.0.2/libctn/libctn.a '
CLUSLIB = 'clustering/libclustering/libclustering.a ' 
PNGLIB = 'libpng-1.2.8/libpng/libpng.a '
ZLIB = 'zlib-1.2.3/zlib/zlib.a '
JPEGLIB = 'jpeg-6b/jpeg/jpeg.a '

// Name of Scilab function library
libname='imlab'

// Title of the toolbox
libtitle='ImLab2.1';



// New functions
imlab_functions=['image_read';..
                 'immaskgreylevel';..
				'immaskrgb';..
				'createcmap';..
				'createcmap128colors';..
				'createcmap256colors';..
				'createcmap4096colors';..
				'image_erode';..
				'image_dilate';..
				'image_average';..
				'compute_hist';..
				'computegreylevelprofile';..
				'computergbprofile';..
				'createmask';..
				'write_pgm';..
				'write_ppm';..
				'write_png_rgb';..
				'write_png_gray';..
				'otsu_image';..
				'deriche_image';..
				'image_label';..
				'image_close_hole';..
				'image_convol';..
				'shencastan_image';..
				'computexyz2lab';..
				'computehist3D';..
				'image_median';..
				'maxcompoconnex';..
				'shape_analysis';..
				'dcmelement';..
				'dcmheader';..
				'learning_data';..
				'kmeans_train';..
				'kmeans_classify';..
				'image_sdeviation';..
				'fuzzykmeans_train';..
				'fuzzykmeans_classify';..
				'fuzzykmeans_classify_2';..
				'hierarclus_train';..
				'kohonen_train';..
				'vote';..
				'growing'];

// Message to propose demonstration
mess=[' ';' ';libtitle+' loaded';'execute ""imlabdemos()"" for demonstrations']


// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'loader.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
  	end
end



//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then

	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR;
	end
	MACROS=DIR+'macros/'

	STDCPPLIB = DIR+'src/libstdc++.a'

	// Add primitives
	A = DIR+'src/'+['imlab_gateway.o' 'imlab.a' TIFFLIB CTNLIB CLUSLIB PNGLIB ZLIB JPEGLIB ] + LIBGCC
	AA = [A STDCPPLIB]
	addinter(AA,'imlab_gateway',imlab_functions)

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR;
	end
	DIR=strsubst(DIR,'/','\');
	MACROS=DIR+'macros\'

	// Add primitives
	addinter(DIR+'src\imlab.dll',"imlab_gateway",imlab_functions)
end

// Load the library
execstr(libname+'=lib(""'+MACROS+'"")')

// Add the help chapter
write(%io(2),mess)
if ~MSDOS then
   %helps = [%helps; DIR+'man\en\imlab', libtitle]
else
   %helps = [%helps; DIR+'man/en/imlab', libtitle]
end
//chfact;

// Add imlabdemo() to the demo menu
if isdef('demolist') then
	if ~MSDOS then
		demolist=[demolist; 'Imlab2.1', DIR+'examples/imlabdemos.dem']
	else
		demolist=[demolist; 'Imlab2.1', DIR+'examples\imlabdemos.dem']
	end
end

// Clean environment
clear libname libtitle imlab_functions mess nams DIR
