function [convol_image]=imconvol(image,mykernel,mask)
	mode(-1);

	// Read number of arguments
	[lhs,rhs] = argn(0);

	image_size=size(image);
	dimension=size(image_size);
	image_type=type(image);
	kernel_type=type(mykernel);

	// Verify mask good definition
	if rhs<=2 then
		mask=ones(image_size(1), image_size(2));
	end
	mask_size=size(mask);

	if (mask_size(1)<>image_size(1)) | (mask_size(2)<>image_size(2)) then
		disp('Image and mask must have the same size!');
		convol_image='err';
		return;
	end

	// Verify kernel good definition
	mykernel_size=size(mykernel);
	dimension=size(mykernel_size);
	if kernel_type<>1 then
		disp('Bad kernel definition.')
		convol_image='err';
		return;
	// Verify if kernel has odd dimensions
	elseif mykernel_size(1)-int(mykernel_size(1)/2)*2==0 then
		disp('Kernel must have odd dimensions.')
		convol_image='err';
		return;
	elseif mykernel_size(2)-int(mykernel_size(2)/2)*2==0 then
		disp('Kernel must have odd dimensions.')
		convol_image='err';
		return;
	elseif (mykernel_size(1)>=image_size(1)) | (mykernel_size(2)>=image_size(2)) then
		disp('Kernel is bigger than image!')
		convol_image='err';
		return;
	else
		if image_type==1 then
			convol_image=image_convol(image(:,:),mykernel(:,:), mask);
			return;
		else
			disp('The image to convol should have only one plan.')
			convol_image='err';
			return;
		end
	end
endfunction
