function [masked_image]=immask(image,mask)
	mode(-1);
	// Image size
	image_size=size(image);
	width=image_size(1);
	height=image_size(2);
	dimension=size(image_size);
	mask_size=size(mask);

	mat_type=type(image);

	if (mask_size(1)<>image_size(1)) | (mask_size(2)<>image_size(2)) then
		disp('Image and mask must have the same size!');
		masked_image='err';
	elseif mat_type==1 then
		masked_image=immaskgreylevel(image,mask);
	elseif mat_type==17 then
		[reddata greendata bluedata]=immaskrgb(image(:,:,1),image(:,:,2),image(:,:,3),mask);
		masked_image=[reddata greendata bluedata];
		image_size=size(masked_image);
		masked_image=matrix(masked_image,image_size(1),image_size(2)/3,3);
	else
		masked_image='err';
		disp('Image format unknown.');
	end
endfunction
