function [imagetoshow]=imshow(image,mask)
	mode(-1);
	
	// Number of input arguments
	rhs=argn(2);
	// In case of 2 arguments, second one is a mask
	// Image is masked and the ouput value will be equal to the image under the mask
	if rhs==2 then
		imagetoshow=immask(image,mask);
	else
		imagetoshow=image;
	end

	mat_type=type(image);

	//disp('Be patient, this may take a while particularly on Windows platforms.');
	
	if mat_type==1 then // 2D matrix => grey level matrix
		imshowgreylevel(imagetoshow,1);
	elseif mat_type==17 then //3D matrix => color matrix
		imshowrgb(imagetoshow,1);
	else
		disp('This image format is not included.');
		imagetoshow='err';
	end
endfunction

