// Modified, as of 05-02-05
// . moved the "clear current graphic window" to the beginning to
//   prevent multiple redraws
// . disabled pixmap mode to prevent the window from not being redraw
//   after zooms unless overlapped 

function []=imshowgreylevel(image,cursor)
	mode(-1);

	set("figure_style","old");

	image_size=size(image);
	width=image_size(1);
	height=image_size(2);

	// Clear current graphic window

	xbasc();
	if (width<400) & (height<300) then
		xset('wdim',398, 298); // Scilab graphic window minimum size
		xsetech(wrect=[0,0,1,1],frect=[0,-1,width+1,height],arect=[(398-width)/(398*2),(398-width)/(398*2),(298-height)/(298*2),(298-height)/(298*2)]);
	else
		xset('wdim',width, height);
  		xsetech(wrect=[0,0,1,1],frect=[0,-1,width+1,height],arect=[0,0,0,0]);
		if (width>900) | (height>600) then xset('wpos',1,1); end
	end
	
	// Force image to be a 256 levels image
	displayed_image=im256(image);

	// Colormap creation
	// Try to allocate 256 colors
	ierr=execstr('xset(''colormap'',graycolormap(256))','errcatch');

	// In case of error, we allocate 253 colors
	// 256 colors platform
	// 253 grey levels + black + white + red (to draw ROIs)
	if ierr<>0
		xset('colormap',graycolormap(253));
		disp('256 colors platform!');
	end

	xset('wresize',0);
	// Pixmap mode => faster
	xset('pixmap',1);
	Matplot1(displayed_image', rect=[0,-1,width+1,height]);
	// Display pixmap
	xset('wshow');
	///if MSDOS then
	///	xbasr(xget('window')); // To avoid problems under Windows platform, but slower
	///end
	if cursor==1 then // To have a cursor on the image
		// Grey level value display
		while 1
			rep=xgetmouse(); // Cursor position
			x=rep(1);
			y=rep(2);
			button=rep(3);
			if (x>=0)&(x<width)&(y<=height)&(y>0) then
				//To point a value in matrix
				x=floor(x)+1;
				y=height-ceil(y)+1;
				position=sprintf('x=%d y=%d Grey level=%f', x, y, image(x,y));
				xinfo(position);
			else
				// Can't exist if wresize=1
				xinfo('Out of image!');
			end;
			if button==5 then break,end // Right clic to exit
		end
	end
	// End of pixmap mode
	//xset('pixmap',0);

endfunction
