mode(-1);
//---------------------------------------------------------------------
// This builder.sce file comes from GUIDELINE contribution
// and has been customed for compiling clustering library
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Visual C path
VC_PATH1='C:\Program Files\Microsoft Visual Studio\VC98'

UNIXLIB = 'libclustering.a'
WINLIB = 'libclustering.lib'

CLUS_OBJS  = 'neuralnet.o kmeanslib.o fuzzykmeanslib.o hierarcluslib.o kohonenlib.o '

UNIX_OBJ = ''

CLUS_OBJS_WIN=strsubst(CLUS_OBJS,'.o','.obj')

disp('Making all in clustering library');
disp('Be patient, this may take a while')

// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SOURCE=DIR+'libclustering/'

	// Create Makefile for source files
	u=file('open',SOURCE+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'LIBCLUSDIR = '+DIR
		'LIBRARY = '+UNIXLIB // Object file library
		'OBJSC = '+CLUS_OBJS+UNIX_OBJ //C objects
		'include '+SCI+'/Makefile.incl'

		'CFLAGS_CLUS = -I./'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(CFLAGS_CLUS)'

		'FFLAGS_CLUS = -I./'
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(FFLAGS_CLUS)'

		'include '+SCI+'/routines/Make.lib'],'(a)')
	file('close',u)
	cmd_make_clus='make'

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	
	// Path of the C-source files directory
  	SOURCE=DIR+'libclustering\'

	// Scilab path under Windows 
  	SCI_WIN=strsubst(SCI,'/','\') 

	// Create Makefile
 	u=file('open',SOURCE+'Makefile','unknown')
  	tab=code2str(-40)
  	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'LIB = lib'
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib""'
  		'LIBRARY = '+WINLIB // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+CLUS_OBJS_WIN //C objects files
  		'include ..\..\..\Makefile.incl.mak'
		
		'CFLAGS_CLUS = -I.' // clustering library
  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+VC_PATH1+'\include"" -I""'+SCI_WIN+'\routines"" $(CFLAGS_CLUS) '
		
		'FFLAGS_CLUS = -I.' // clustering library
		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""'+VC_PATH1+'\include"" $(FFLAGS_CLUS) '
  		
   		'all :: '+WINLIB // Static library
		WINLIB+' : $(OBJSC)'
		tab+'@$(LIB) /out:'+WINLIB+' $(OBJSC)'],'(a)')
  	file('close',u)
	cmd_make_clus='nmake /f Makefile'
end

// compile Fortran and C sources in src
OLDDIR=getcwd();
chdir(SOURCE)
unix_s(cmd_make_clus)
chdir(OLDDIR);
disp('Clustering library compiled')

clear VC_PATH1 OBJFILELIB WINLIBRARY DLLNAME INTERFACE_FILE COBJFILES COBJFILESWIN nams DIR SOURCE cmd_make_clus SCI_WIN OLDDIR
