#include "hypermatrix.h"

#ifndef NEURALNET_H
#define NEURALNET_H

#define GENERIC_NN_PROTO      0x0002

#ifdef __cplusplus


#define LearningData(i_point, i_fun, i_comp) learningData.R[(i_point) + (i_fun)*nbPoints + (i_comp)*nbPoints*inputSpaceDim]

#define Proto(i_fun, i_class, i_comp) proto.R[(i_fun) + (i_class)*inputSpaceDim + (i_comp)*inputSpaceDim*classCount]

#define PrivateProto(i_fun, i_class, i_comp) privateProto.R[(i_fun) + (i_class)*inputSpaceDim + (i_comp)*inputSpaceDim*classCount]

#define PrivProto(i_fun, i_class, i_comp) privProto.R[(i_fun) + (i_class)*inputSpaceDim + (i_comp)*inputSpaceDim*classCount]


class NeuralNet {

	protected :

		int nbComp; // Image component number (3 for example if colour images)
		int classCount; // Classe number
		int inputSpaceDim; // Computed images number

		NeuralNet (int nNbComp, int nClassNumber, int nInputDimension);

		~NeuralNet();

		void allocPrivateProto(); // Memory allocation for temporary weights

		void freePrivateProto(); // Memory desallocation for temporary weights

		void sortProto(HyperMat proto, int component = 0); // Sort prototype in increasing order

		HyperMat privateProto; // Temporary weights

		short flags;

		/* This function initialise the prototype thanks to learningData */
		void initProto(HyperMat learningData, HyperMat proto);

		int allocPrivProto(HyperMat *privProto, HyperMat learningData);

		void freePrivProto(HyperMat *privProto);


	private :

		int initProtoKmeans(HyperMat learningData, HyperMat proto, int index);


};

#endif

#endif

