
#include "int_hypermatrix.h"

int get_rhs_hmat(int pos, HyperMat *H)
{
  char **Str2;
  int m,n,l,m1,n1,m2,n2,l2,m3,n3,l3,it3,lc3;
  GetRhsVar(pos,"m",&m,&n,&l);
  CheckLength(pos,m,3);
  GetListRhsVar(pos,1,"S",&m1,&n1,&Str2);
  if ( strcmp(Str2[0],"hm") != 0)
    {
      Scierror(999,"Argument %d is not an hypermatrix\r\n",pos);
      return 0;
    }
  GetListRhsVar(pos,2,"i",&m2,&n2,&l2);
  GetListRhsCVar(pos,3,"d",&it3,&m3,&n3,&l3,&lc3);
  H->dims = istk(l2);
  H->dimsize = m2*n2;
  H->size = m3*n3;
  H->R = stk(l3);
  H->I = (it3==1) ? stk(lc3): NULL;
  H->it= it3;
  // we must free Str2 memory
  FreeRhsSVar(Str2);
  return 1;
}


int cre_hmat(int pos, HyperMat *H)
{
  static char *Str[]= { "hm","dims","entries"}; int m1=1,n1=3;
  int mL=3,nL=1,lL, un=1;
  CreateVar(pos,"m", &mL, &nL, &lL);
  CreateListVarFromPtr(pos,1,"S", &m1, &n1, Str);
  CreateListVarFromPtr(pos,2,"i",&un, &H->dimsize, &H->dims);
  CreateListCVarFromPtr(pos,3,"d", &H->it,&H->size,&un ,&H->R,&H->I);
  return 1;
}





