
#ifndef INTIMFUZZYKMEANSCLASSIFY_H
#define INTIMFUZZYKMEANSCLASSIFY_H

#include "int_hypermatrix.h"


/**************************************************************************************************************/
/* Interface Scilab<->imfuzzykmeansclassify                                                                   */
/**************************************************************************************************************/
/* Creation : 01/04/2004 (V. POMMEREUL)                                                                       */
/**************************************************************************************************************/
int int_imfuzzykmeansclassify(char *fname);


/**************************************************************************************************************/
/* Fuzzy k-means method classification phase function for a 2D image                                          */
/**************************************************************************************************************/
int classify_fuzzykmeans_2D(double *proto, int nbIm, int nbClasses, double *mask, double *weights, double fuzzyness, 		double threshold1, double threshold2, double *image[NBIMAGES_MAX], int height, int width, double **classes_image);


/**************************************************************************************************************/
/* Fuzzy k-means method classification phase function for a 3D image                                          */
/**************************************************************************************************************/
int classify_fuzzykmeans_3D(double *proto, int nbIm, int nbClasses, HyperMat mask, double *weights, double fuzzyness, 		double threshold1,double threshold2, HyperMat images[NBIMAGES_MAX], HyperMat *classes_image);


/**************************************************************************************************************/
/* Fuzzy k-means method classification phase function for a 4D image                                          */
/**************************************************************************************************************/
int classify_fuzzykmeans_4D(HyperMat proto, HyperMat mask, double *weights, double fuzzyness, double threshold1,
	double threshold2, HyperMat images[NBIMAGES_MAX], HyperMat *classes_image);


#endif


