
#ifndef INTIMFUZZYKMEANSTRAIN_H
#define INTIMFUZZYKMEANSTRAIN_H

#include "int_hypermatrix.h"

/******************************************************************************/
/* Interface Scilab<->imfuzzykmeanstrain                                      */
/******************************************************************************/
int int_imfuzzykmeanstrain(char *fname);

/******************************************************************************/
/* Fuzzy k-means method training phase function for a 2D image                */
/******************************************************************************/
int train_fuzzykmeans_mat(double *learningData, int nbPoints, int nbFunc, int nbClasses,
					double threshold, int nbIter, double fuzzyness, double **prototype);

/******************************************************************************/
/* Fuzzy k-means method training phase function for a 3D or 4D image          */
/******************************************************************************/
int train_fuzzykmeans_hypmat(HyperMat learningData, int nbClasses, double threshold,
					int nbIter, double fuzzyness, HyperMat *prototype);

#endif


