
#ifndef INTIMKMEANSCLASSIFY_H
#define INTIMKMEANSCLASSIFY_H

#include "int_hypermatrix.h"

/******************************************************************************/
/* Interface Scilab<->imkmeansclassify                                        */
/******************************************************************************/
int int_imkmeansclassify(char *fname);

/******************************************************************************/
/* Kmeans method classification phase function for a 2D image                 */
/******************************************************************************/
int classify_kmeans_2D(double *proto, int nbIm, int nbClasses, double *mask, double *weights,
				double *image[NBIMAGES_MAX], int height, int width, double **classes_image);

/******************************************************************************/
/* Kmeans method classification phase function for a 3D image                 */
/******************************************************************************/
int classify_kmeans_3D(double *proto, int nbIm, int nbClasses, HyperMat mask, double *weights,
				HyperMat images[NBIMAGES_MAX], HyperMat *classes_image);

/******************************************************************************/
/* Kmeans method classification phase function for a 4D image                 */
/******************************************************************************/
int classify_kmeans_4D(HyperMat proto, HyperMat mask, double *weights,
				HyperMat images[NBIMAGES_MAX], HyperMat *classes_image);


#endif


