
#ifndef INTIMKMEANSTRAIN_H
#define INTIMKMEANSTRAIN_H

#include "int_hypermatrix.h"

/******************************************************************************/
/* Interface Scilab<->imkmeanstrain                                           */
/******************************************************************************/
int int_imkmeanstrain(char *fname);

/******************************************************************************/
/* K-means method training phase function for a 2D image                      */
/******************************************************************************/
int train_kmeans_mat(double *learningData, int nbPoints, int nbFunc, int nbClasses,
					double threshold, int nbIter, double **prototype);

/******************************************************************************/
/* K-means method training phase function for a 3D or 4D image                */
/******************************************************************************/
int train_kmeans_hypmat(HyperMat learningData, int nbClasses, double threshold,
					int nbIter, HyperMat *prototype);

#endif


