
#ifndef INTIMLABEL_H
#define INTIMLABEL_H

#ifndef bool
typedef int bool;
#define true 1
#define false 0
#endif

/******************************************************************************/
/* Interface Scilab <-> imlabel                                               */
/******************************************************************************/
/* Creation : 09/04/2002 (V. COUVERT)                                         */
/* Last modification : 09/06/2005 (M. TALLUR)                                 */
/******************************************************************************/
int int_imlabel(char *fname);

/******************************************************************************/
/* Labelling main function                                                    */
/******************************************************************************/
int label(double *image, int width, int height, int connectivity, 
		  double **label_image, int *nb_objects, int *ierr, int vertical_parsing);

struct imlabel_synonym
{
	struct imlabel_synonym *next;
	long value;
	long synonym;
};

struct imlabel_integer
{
	struct imlabel_integer *next;
	long value;
};

struct imlabel_list
{
	struct imlabel_integer *head, *tail;
};

// for each pixel, we consider the pixel on the right, then the pixel below, and optionally the pixels below on the diagonals
static int neighboffset_x[4] = {1, 0, 1, -1};
static int neighboffset_y[4] = {0, 1, 1, 1};

static bool imlabel_belongsToList(long value, struct imlabel_integer *head);
static bool imlabel_coupleBelongsToList(long value, long syn, struct imlabel_synonym *head);
static void imlabel_addSynonym(struct imlabel_synonym **head, struct imlabel_synonym **tail, long value1, long value2);
static bool imlabel_addInteger(struct imlabel_integer **head, struct imlabel_integer **tail, long value, int check);
static bool imlabel_convertSynsListToSynsListsList(struct imlabel_list ***newlist, struct imlabel_synonym *head, long count);
static long imlabel_minimum(struct imlabel_integer *head);
static void imlabel_spreadSynonyms(struct imlabel_list **list, long count);
static void imlabel_convertSynsListsListToSynsTable(long **tab, struct imlabel_list **list, long count);
static void imlabel_emptyList(struct imlabel_synonym *head);
static void imlabel_emptyListsList(struct imlabel_list **list, long count);


#endif
