
#ifndef INTIMLEARNINGDATA_H
#define INTIMLEARNINGDATA_H

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "stack-c.h"
#include "int_hypermatrix.h"

/******************************************************************************/
/* Interface Scilab<->imlearningdata                                          */
/******************************************************************************/
int int_imlearningdata(char *fname);

/******************************************************************************/
/* Create learning data from 2D images (used in training phases)              */
/******************************************************************************/
int learningdata_2D(int nbIm, int pointsNb, double *mask, double *weights,
					double *images[NBIMAGES_MAX], int height, int width, double **learningData);

/******************************************************************************/
/* Create learning data from 3D images (used in training phases)              */
/******************************************************************************/
int learningdata_3D(int nbIm, int pointsNb, HyperMat mask, double *weights,
					HyperMat images[NBIMAGES_MAX], double **learningData);

/******************************************************************************/
/* Create learning data from 4D images (used in training phases)              */
/******************************************************************************/
int learningdata_4D(int nbIm, int pointsNb, HyperMat mask, double *weights,
					HyperMat images[NBIMAGES_MAX], HyperMat *learningData);


/******************************************************************************/
/* Create learning data                                                       */
/******************************************************************************/
void create_learningdata(HyperMat mask, double *weights, HyperMat images[NBIMAGES_MAX], HyperMat learningData);

#endif


