
#ifndef INTIMREAD_H
#define INTIMREAD_H

/******************************************************************************/
/* Interface Scilab<->read_image                                              */
/******************************************************************************/
/* Creation : 09/07/2001 (V. COUVERT)                                         */
/* Last modification : 23/06/2004 (V. POMMEREUL)                              */
/******************************************************************************/
int int_imread(char *fname);


/******************************************************************************/
/* Function which call the function needed according to the file type         */
/******************************************************************************/
int read_image(char *filename, 
			   unsigned int **redimage, unsigned int **greenimage, 
			   unsigned int **blueimage, int *m, int *n, int *colour, int *ierr);


/******************************************************************************/
/* Function used to read a PGM extension file                                 */
/* 8-bit grey level image                                                     */
/******************************************************************************/
int read_pgm(char *filename, unsigned int **image, int *m, int *n);


/******************************************************************************/
/* Function used to read a PPM extension file                                 */
/* 24-bit color image                                                         */
/******************************************************************************/
int read_ppm(char *filename, unsigned int **redimage, unsigned int **greenimage, unsigned
 int **blueimage, int *m, int *n);

/******************************************************************************/
/* Function used to read a TIFF extension file                                */
/* 16-bit grey level image                                                    */
/* Be careful that a TIFF file can contain others image formats               */
/******************************************************************************/
int read_tif(char *filename, unsigned int **image, int *m, int *n);


/******************************************************************************/
/* Function used to read a DCM extension file                                 */
/* 12-bit grey level image                                                    */
/******************************************************************************/
int read_dcm(char *filename, unsigned int **image, int *m, int *n);

int read_bmp(char *filename, unsigned int **redimage, unsigned int **greenimage, unsigned int **blueimage, int *m, int *n, int *colour);

int read_png(char *filename, unsigned int **redimage, unsigned int **greenimage, unsigned int **blueimage, int *m, int *n, int *colour);

int read_jpg(char *filename, unsigned int **redimage, unsigned int **greenimage, unsigned int **blueimage, int *m, int *n, int *colour);

typedef struct BITMAPINFOHEADER {
        int biSize;        // Taille de cette structure en octets.
        int biWidth;       // Largeur du bitmap en pixel.
        int biHeight;      // Hauteur du bitmap en pixel.
        int biPlanes;   // (2 octets) 1
        int biBitCount; // (2 octets) Bits couleurs par pixel.
        int biCompression; // Schma de compactage (0 pour aucun).
        int biSizeImage;   //Taille de l'image en octets (utile pour le compactage).
        int biXpelsPerMeter; // Rsolution horizontale en pixels par mtre.
        int biYpelsPerMeter; // Rsolution verticale en pixels par mtre.
        int biClrUsed; // Nombre de couleurs utilises dans l'image.
        int biClrImportant; // Nombre de couleurs importantes.
}bmpinfo;

struct rgbColour {
	int red;
	int green;
	int blue;
};


#endif







