mode(-1);
//---------------------------------------------------------------------
// This builder.sce file comes from GUIDELINE contribution
// and has been customed for compiling JPEG library
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Visual C path
//VC_PATH1='C:\PROGRA~1\MICROS~2\VC98'
VC_PATH1='C:\Program Files\Microsoft Visual Studio\VC98'


UNIXLIB = 'jpeg.a'
WINLIB = 'jpeg.lib'

CTN_OBJS =	'ansi2knr.o '+..
		'cdjpeg.o '+..
		'cjpeg.o '+..
		'ckconfig.o '+..
		'djpeg.o '+..
		'jcapimin.o '+..
		'jcapistd.o '+..
		'jccoefct.o '+..
		'jccolor.o '+..
		'jcdctmgr.o '+..
		'jchuff.o '+..
		'jcinit.o '+..
		'jcmainct.o '+..
		'jcmarker.o '+..
		'jcmaster.o '+..
		'jcomapi.o '+..
		'jcparam.o '+..
		'jcphuff.o '+..
		'jcprepct.o '+..
		'jcsample.o '+..
		'jctrans.o '+..
		'jdapimin.o '+..
		'jdapistd.o '+..
		'jdatadst.o '+..
		'jdatasrc.o '+..
		'jdcoefct.o '+..
		'jdcolor.o '+..
		'jddctmgr.o '+..
		'jdhuff.o '+..
		'jdinput.o '+..
		'jdmainct.o '+..
		'jdmarker.o '+..
		'jdmaster.o '+..
		'jdmerge.o '+..
		'jdphuff.o '+..
		'jdpostct.o '+..
		'jdsample.o '+..
		'jdtrans.o '+..
		'jerror.o '+..
		'jfdctflt.o '+..
		'jfdctfst.o '+..
		'jfdctint.o '+..
		'jidctflt.o '+..
		'jidctfst.o '+..
		'jidctint.o '+..
		'jidctred.o '+..
		'jmemansi.o '+..
		'jmemmgr.o '+..
		'jmemname.o '+..
		'jmemnobs.o '+..
		'jpegtran.o '+..
		'jquant1.o '+..
		'jquant2.o '+..
		'jutils.o '+..
		'rdbmp.o '+..
		'rdcolmap.o '+..
		'rdgif.o '+..
		'rdjpgcom.o '+..
		'rdppm.o '+..
		'rdrle.o '+..
		'rdswitch.o '+..
		'rdtarga.o '+..
		'transupp.o '+..
		'wrbmp.o '+..
		'wrgif.o '+..
		'wrjpgcom.o '+..
		'wrppm.o '+..
		'wrrle.o '+..
		'wrtarga.o '

CTN_OBJS_WIN=strsubst(CTN_OBJS,'.o','.obj')

disp('Making all in JPEG library version 6b');
disp('Be patient, this may take a while')
// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SOURCE=DIR+'jpeg/';

	// Create Makefile for source files
	u=file('open',SOURCE+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'IMLABDIR = '+DIR
		'LIBRARY = '+UNIXLIB // Object file library
		'OBJSC = '+CTN_OBJS //C objects
		'include '+SCI+'/Makefile.incl'

		'CFLAGS_JPEG = -I.'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(CFLAGS_JPEG)'

		'FFLAGS_JPEG = -I.'
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(FFLAGS_JPEG)'

		'include '+SCI+'/routines/Make.lib'],'(a)')
	file('close',u)
	cmd_make_ctn='make'

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end

	// Path of the C-source files directory
  	SOURCE=DIR+'jpeg\'

	// Scilab path under Windows
  	SCI_WIN=strsubst(SCI,'/','\')


	// Create Makefile
 	u=file('open',SOURCE+'Makefile','unknown')
  	tab=code2str(-40)
  	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'LIB = lib'
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib""'
  		'LIBRARY = '+WINLIB // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+CTN_OBJS_WIN//C objects files
  		'include ..\..\..\Makefile.incl.mak'

		'CFLAGS_JPEG = -I.' // JPEG library
  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+VC_PATH1+'\include"" -I""'+SCI_WIN+'\routines"" $(CFLAGS_JPEG) '

		'FFLAGS_JPEG = -I.' // JPEG library
		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""'+VC_PATH1+'\include"" $(FFLAGS_JPEG) '

		'all :: '+WINLIB // Static library
		WINLIB+' : $(OBJSC)'
		tab+'@$(LIB) /out:'+WINLIB+' $(OBJSC)'],'(a)')
  	file('close',u)
	cmd_make_ctn='nmake /f Makefile'
end

// compile Fortran and C sources in src
OLDDIR=getcwd();
chdir(SOURCE)
unix_s(cmd_make_ctn)
chdir(OLDDIR);
disp('JPEG library compiled')

clear VC_PATH1 OBJFILELIB WINLIBRARY DLLNAME INTERFACE_FILE COBJFILES COBJFILESWIN nams DIR SOURCE cmd_make_ctn SCI_WIN OLDDIR
