mode(-1);
//---------------------------------------------------------------------
// This builder.sce file comes from GUIDELINE contribution
// and has been customed for compiling PNG library
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Visual C path
//VC_PATH1='C:\PROGRA~1\MICROS~2\VC98'
VC_PATH1='C:\Program Files\Microsoft Visual Studio\VC98'


UNIXLIB = 'libpng.a'
WINLIB = 'libpng.lib'

CTN_OBJS =	'png.o '+..
		'pngerror.o '+..
		'pnggccrd.o '+..
		'pngget.o '+..
		'pngmem.o '+..
		'pngpread.o '+..
		'pngread.o '+..
		'pngrio.o '+..
		'pngrtran.o '+..
		'pngrutil.o '+..
		'pngset.o '+..
		'pngtrans.o '+..
		'pngvcrd.o '+..
		'pngwio.o '+..
		'pngwrite.o '+..
		'pngwtran.o '+..
		'pngwutil.o '

CTN_OBJS_WIN=strsubst(CTN_OBJS,'.o','.obj')

disp('Making all in PNG library version 1.2.8');
disp('Be patient, this may take a while')
// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SOURCE=DIR+'libpng/';

	// Create Makefile for source files
	u=file('open',SOURCE+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'IMLABDIR = '+DIR
		'LIBRARY = '+UNIXLIB // Object file library
		'OBJSC = '+CTN_OBJS //C objects
		'include '+SCI+'/Makefile.incl'

		'CFLAGS_PNG = -I.'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(CFLAGS_PNG)'

		'FFLAGS_PNG = -I.'
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(FFLAGS_PNG)'

		'include '+SCI+'/routines/Make.lib'],'(a)')
	file('close',u)
	cmd_make_ctn='make'

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	
	// Path of the C-source files directory
  	SOURCE=DIR+'libpng\'

	// Scilab path under Windows 
  	SCI_WIN=strsubst(SCI,'/','\') 


	// Create Makefile
 	u=file('open',SOURCE+'Makefile','unknown')
  	tab=code2str(-40)
  	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'LIB = lib'
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib""'
  		'LIBRARY = '+WINLIB // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+CTN_OBJS_WIN//C objects files
  		'include ..\..\..\Makefile.incl.mak'
		
		'CFLAGS_PNG = -I. -I..\..\zlib-1.2.3\zlib ' // png library
  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+VC_PATH1+'\include"" -I""'+SCI_WIN+'\routines"" $(CFLAGS_PNG) '
		
		'FFLAGS_PNG = -I.' // png library
		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""'+VC_PATH1+'\include"" $(FFLAGS_PNG) '
  		
		'all :: '+WINLIB // Static library
		WINLIB+' : $(OBJSC)'
		tab+'@$(LIB) /out:'+WINLIB+' $(OBJSC)'],'(a)')
  	file('close',u)
	cmd_make_ctn='nmake /f Makefile'
end

// compile Fortran and C sources in src
OLDDIR=getcwd();
chdir(SOURCE)
unix_s(cmd_make_ctn)
chdir(OLDDIR);
disp('PNG library compiled')

clear VC_PATH1 OBJFILELIB WINLIBRARY DLLNAME INTERFACE_FILE COBJFILES COBJFILESWIN nams DIR SOURCE cmd_make_ctn SCI_WIN OLDDIR
