mode(-1);
//---------------------------------------------------------------------
// This builder.sce file comes from GUIDELINE contribution
// and has been customed for compiling TIFF library
// ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/contrib/GUIDELINE/
//---------------------------------------------------------------------

// Visual C path
//VC_PATH1='C:\PROGRA~1\MICROS~2\VC98'
VC_PATH1='C:\Program Files\Microsoft Visual Studio\VC98'


UNIXLIB = 'libtiff.a'
WINLIB = 'libtiff.lib'

TIFF_OBJS	= 'tif_aux.o '+..
		'tif_close.o '+..
		'tif_codec.o '+..
		'tif_compress.o '+..
		'tif_dir.o '+..
		'tif_dirinfo.o '+..
		'tif_dirread.o '+..
		'tif_dirwrite.o '+..
		'tif_dumpmode.o '+..
		'tif_error.o '+..
		'tif_fax3.o '+..
		'fax3sm_winnt.o '+..
		'tif_getimage.o '+..
		'tif_jpeg.o '+..
		'tif_flush.o '+..
		'tif_luv.o '+..
		'tif_lzw.o '+..
		'tif_next.o '+..
		'tif_ojpeg.o '+..
		'tif_open.o '+..
		'tif_packbits.o '+..
		'tif_pixarlog.o '+..
		'tif_predict.o '+..
		'tif_print.o '+..
		'tif_read.o '+..
		'tif_swab.o '+..
		'tif_strip.o '+..
		'tif_thunder.o '+..
		'tif_tile.o '+..
		'tif_version.o '+..
		'tif_warning.o '+..
		'tif_write.o '+..
		'tif_zip.o '

UNIX_OBJ = 'tif_unix.o '
WIN_OBJ = 'tif_win32.obj '

TIFF_OBJS_WIN=strsubst(TIFF_OBJS,'.o','.obj')

disp('Making all in TIFF library version 3.5.7');
disp('Be patient, this may take a while')

// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SOURCE=DIR+'libtiff/'

	// Create Makefile for source files
	u=file('open',SOURCE+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'LIBTIFFDIR = '+DIR
		'LIBRARY = '+UNIXLIB // Object file library
		'OBJSC = '+TIFF_OBJS+UNIX_OBJ //C objects
		'include '+SCI+'/Makefile.incl'

		'CFLAGS_TIFF = -I./'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(CFLAGS_TIFF)'

		'FFLAGS_TIFF = -I./'
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines $(FFLAGS_TIFF)'

		'include '+SCI+'/routines/Make.lib'],'(a)')
	file('close',u)
	cmd_make_tiff='make'

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	
	// Path of the C-source files directory
  	SOURCE=DIR+'libtiff\'

	// Scilab path under Windows 
  	SCI_WIN=strsubst(SCI,'/','\') 

	// Create Makefile
 	u=file('open',SOURCE+'Makefile','unknown')
  	tab=code2str(-40)
  	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'LIB = lib'
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib""'
  		'LIBRARY = '+WINLIB // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+TIFF_OBJS_WIN+WIN_OBJ//C objects files
  		'include ..\..\..\Makefile.incl.mak'
		
		'CFLAGS_TIFF = -I.' // tiff library
  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+VC_PATH1+'\Include"" -I""'+SCI_WIN+'\routines"" $(CFLAGS_TIFF) '
		
		'FFLAGS_TIFF =  -I.' // tiff library
		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""'+VC_PATH1+'\include"" $(FFLAGS_TIFF) '
  		
   		'all :: '+WINLIB // Static library
		WINLIB+' : $(OBJSC)'
		tab+'@$(LIB) /out:'+WINLIB+' $(OBJSC)'],'(a)')
  	file('close',u)
	cmd_make_tiff='nmake /f Makefile'
end

// compile Fortran and C sources in src
OLDDIR=getcwd();
chdir(SOURCE)
unix_s(cmd_make_tiff)
chdir(OLDDIR);
disp('TIFF library compiled')

clear VC_PATH1 OBJFILELIB WINLIBRARY DLLNAME INTERFACE_FILE COBJFILES COBJFILESWIN nams DIR SOURCE cmd_make_tiff SCI_WIN OLDDIR
